#include<iostream>
#include<algorithm>
using namespace std;

long long a[200000];
int main()
{
	long long n, q, p, l, d, br=0;
	cin>>n>>q>>p;
	char ch;
	for(long long i=0; i<n; i++)
	{
		cin>>ch;
		a[i]=ch-'0';
	}
	for(long long r=0; r<p; r++)
	{
		cin>>l>>d;
		for(long long i=l-1; i<=d-1; i++)
		{
			a[i]=!a[i];
		}
		for(long long i=0; i<n; i++)
		{
			if(a[i]==1)br++;
		}
		cout<<min(br, n-br);
    }
	return 0;
}